#ifndef _DEBUG_H_
#define _DEBUG_H_

#include <iostream>

#ifndef DEBUG
	#define ASSERT(X)
	#define WARN(X,Y)
	#define CRITICAL(X) if(!(X))exit(1);
#else
	#define ASSERT(X) \
		if(!(X)) \
		{ \
			std::cerr	<< "ASSERT:\n"; \
			std::cerr	<< "\terror check failed:\t" << #X	<< "\n"	;	\
			std::cerr	<< "\tfile:\t" << __FILE__			<< "\n"	;	\
			std::cerr	<< "\tline:\t" << __LINE__			<< "\n"	;	\
			std::cerr	<< std::endl								;	\
		} 0

	#define WARN(X,Y)													\
		if(! (X))														\
		{																\
			std::cerr	<< "WARNING:\n"								;	\
			std::cerr	<< "\terror check failed:\t" << #X	<< "\n"	;	\
			std::cerr	<< "\tfile:\t" << __FILE__			<< "\n"	;	\
			std::cerr	<< "\tline:\t" << __LINE__			<< "\n"	;	\
			std::cerr	<< "\n" << Y						<< "\n"	;	\
			std::cerr	<< std::endl								;	\
		} 0

	#define CRITICAL(X)													\
		if(!(X))														\
		{																\
			std::cerr	<< "CRITICAL:\n"							;	\
			std::cerr	<< "\terror check failed:\t" << #X	<< "\n"	;	\
			std::cerr	<< "\tfile:\t" << __FILE__			<< "\n"	;	\
			std::cerr	<< "\tline:\t" << __LINE__			<< "\n"	;	\
			std::cerr	<< std::endl								;	\
			exit(1)													;	\
		} 0
#endif

#endif
