#ifndef _ENTITY_H_
#define _ENTITY_H_

#define	PROG_SIZE 4096

#include <list>
#include <algorithm>

#include "vector.h"

class tile;

class entity
{
public:

	entity(unsigned int energy_);
	entity(unsigned int energy_, unsigned int *prog_);
	~entity();

	unsigned int* prog;

	void update();
	void addEnergy(unsigned int e) { energy+=e; }
	void move(char dir);
	

	void BNE();

	void MOV();
	void ADD();
	void SUB();

	void DAT();	

	void EXE();
	
	static unsigned int newProgSeed;

	vector2i pos;
	unsigned int age;
	unsigned int energy;

	unsigned int pc;

	struct entityCompare
	{
		bool operator()(entity* &a, entity* &b)
		{
			return a->age>b->age;
		}
	};

};


#endif