


#ifdef WIN32
#include <windows.h>
#endif

#include <GL/glut.h>

#include <iostream>
#include <vector>
#include <string>



#include "debug.h"

#include "tile.h"
#include "entity.h"
#include "world.h"
#include "display.h"

#define ENTITY_COUNT 20
#define ENTITY_START_ENERGY 10240
#define RANDOM_PROG_PROB 0.2f

extern world *currentWorld;

void cleanup()
{
	delete currentWorld;
	std::cout << "bye!" << std::endl;
}

entity* generateEntity()
{
	entity* newEntity = NULL;
	int i=0;

	if(currentWorld->deadEntities.size()==0 || frand() < RANDOM_PROG_PROB)
	{
		newEntity = new entity(ENTITY_START_ENERGY);
	} else
	{
		unsigned int* prog = new unsigned int[PROG_SIZE];

		while(i<PROG_SIZE )
		{
			unsigned int j = 0;
			world::l_entitiesIt it = currentWorld->deadEntities.begin();
			unsigned int entityToUse = rand()%currentWorld->deadEntities.size();

			for(j=0;j<entityToUse;j++,++it);

			unsigned int cmdCount = rand()%(PROG_SIZE-i);
			for(j=0;j<=cmdCount;j++)
			{
				prog[i]=(*it)->prog[i];
				i++;
			}
		}
		newEntity = new entity(PROG_SIZE,prog);
	}
	return newEntity;
}

void idle()
{
	if(currentWorld)
	{
		currentWorld->update();

		if( currentWorld->getEntityCount() == 0)
		{
			while(currentWorld->getEntityCount() < ENTITY_COUNT)
			{
				entity* ePtr = generateEntity();
				bool added = false;
				while(!added)
				{
					added = currentWorld->addEntity(*ePtr,vector2i(rand()%currentWorld->length,rand()%currentWorld->width));
				}
			}
		}
	}
	glutPostRedisplay();
}

int main(int argc, char** argv)
{
	atexit(cleanup);
	CRITICAL(displayInit(argc,argv));

	glutIdleFunc(idle);

	currentWorld = new world(0,40,40,0.8,0.01,10240);

	glutMainLoop();
	return 0;

}