#ifndef _VECTOR_H_
#define _VECTOR_H_

template<typename T>
class vector2D
{
public:
	vector2D<T>() { x=0; y=0; }
	vector2D<T>(T x_, T y_) { x=x_; y=y_; }
	vector2D<T>(const vector2D<T>& v) { x=v.x; y=v.y; }
	
	vector2D<T> & operator=(const vector2D<T>& v) { x=v.x; y=v.y; return *this; }

	union
	{
		struct
		{
			T x;
			T y;
		};
		T data[2];
	};
};

typedef vector2D<int> vector2i;
typedef vector2D<float> vector2f;
typedef vector2D<double> vector2d;


#endif
