#ifndef _WORLD_H_
#define _WORLD_H_


#define frand() ((float)(rand()%32767)/32767.0f)


#include <list>
#include <queue>

#include "tile.h"
#include "entity.h"
#include "vector.h"

class world
{
public:
	
	world(	unsigned int seed,
			unsigned int length_,
			unsigned int width_,
			float openness_,
			float fertility_,
			unsigned int foodDuration_);
	~world();


	void update() { doWorld(); doEntities(); }

	bool isTileFree(const vector2i& v);
	bool doesTileContainFood(const vector2i& v);

	bool addEntity(entity& e, const vector2i& pos);
	void removeEntity(entity& e);
	void moveEntity(entity& e, const vector2i& to);
	void killEntity(entity* e);
	unsigned int getEntityCount() { return livingEntities.size(); }

	unsigned int length;
	unsigned int width;
	float openness;
	float fertility;
	float foodDuration;
		
	friend void drawWorld();
	friend entity* generateEntity();

protected:

	tile*** grid;

	void doWorld();
	void doEntities();

	typedef std::list<entity*> l_entities;
	typedef l_entities::iterator l_entitiesIt;
		
	l_entities blackList;
	l_entities livingEntities;
	l_entities deadEntities;
};

#endif