

#ifndef __render_h__
#define __render_h__


#include "utilities.h"

typedef void(*void_func_void)(void);

void initRenderingContext(int argc, char* argv[]);

void setMainLoopCallback(void_func_void pIdle);

void setRenderCallback(void_func_void pRender);

void getWindowDimensions( vector2i& dim );

void drawRectangle(	const vector2f* pPos,
					const vector2f* pDim,
					const float* pLineWidth,
					const colour4f* pLineColour,
					const colour4f* pFillColour);

void beginMainLoop();

void drawGrid(	const vector2i& subdivs,
				const vector2f* pPos,
				const vector2f* pDim,
				const float* pLineWidth,
				const colour4f* pLineColour,
				const colour4f* pFillColour);


#endif



