

#ifndef __utilities_h__
#define __utilities_h__

#include "common.h"
#include "vector.h"


typedef vector2i position;
typedef vector2i area;
typedef vector2i direction;


static const direction g_north(0,1);
static const direction g_east(1,0);
static const direction g_south(0,-1);
static const direction g_west(-1,0);


template<typename T>
struct range
{
	union
	{
		struct
		{
			T m_start;
			T m_end;
		};
		T m_range[2];
	};
};




class colour4f
{
public:
	colour4f()	: m_r(0.0f)
				, m_g(0.0f)
				, m_b(0.0f)
				, m_a(0.0f) {}

	colour4f(float r, float g, float b, float a)	: m_r(r)
													, m_g(g)
													, m_b(b)
													, m_a(a) {}

	colour4f(const float c[4])	: m_r(c[0])
								, m_g(c[1])
								, m_b(c[2])
								, m_a(c[3]) {}

	colour4f& operator=(const colour4f& c)
	{
		m_r = c.m_r;
		m_g = c.m_g;
		m_b = c.m_b;
		m_a = c.m_a;
	}

	union
	{
		struct
		{
			float m_r;
			float m_g;
			float m_b;
			float m_a;
		};
		float m_data[4];
	};
};


#endif


