

#ifndef __render_h__
#define __render_h__


#include "utilities.h"


typedef void(*void_func_void)(void);


/// initialise renderer/window
void initRenderingContext(int argc, char* argv[]);

/// set the main loop callback function
void setMainLoopCallback(void_func_void pIdle);

/// set the render callback function
void setRenderCallback(void_func_void pRender);

/// get the window dimensions
void getWindowDimensions( vector2i& dim );


/// draw a rectangle
void drawRectangle(	const vector2f* pPos,
					const vector2f* pDim,
					const float* pLineWidth,
					const colour4f* pLineColour,
					const colour4f* pFillColour);

/// start the main loop
void beginMainLoop();

/// draw a grid
void drawGrid(	const vector2i& subdivs,
				const vector2f* pPos,
				const vector2f* pDim,
				const float* pLineWidth,
				const colour4f* pLineColour,
				const colour4f* pFillColour);


#endif



