/********************************************************************************
 *
 *  urbanVictory engine
 *  Copyright (C) 2003, 2004 Adam Cubitt
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2
 *  of the License, or (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *										
 ********************************************************************************/


/**
 *	\file	utilities.h
 *	\author	Adam Cubitt
 *	\brief	defines basic utilites needed by the maths lib
 */


#ifndef __UTILITIES__
#define __UTILITIES__

#include <cassert>



//////////////////////////////////////////////////////////////////////////
// float comparison macro
#define FCOMPARE(X_, Y_) (((X_)>((Y_) - episilon)) && ( (X_) < ((Y_) + episilon)))
#define LERP(A, B, T) (A*(1.0f-T)+B*T)



//////////////////////////////////////////////////////////////////////////
// basic geometric macros
#define PI 3.1415926535897932384626433832795f
#define TO_RAD(X) (X/180*PI)
#define TO_DEG(X) (X/PI*180)



//////////////////////////////////////////////////////////////////////////
// a small number
extern const float episilon;


#endif 
