

#ifndef __dataIO_h__
#define __dataIO_h__





class writeBinary : public std::ofstream
{
public:
	template< typename T >
		void doData(T* data)
	{
		std::ofstream::write(reinterpret_cast<char*>(data), sizeof(T));
	}

	template< typename T>
		void doDataVector(typename std::vector<T>* dataVector)
	{
		size_t numElements = dataVector->size();
		std::ofstream::write(&numElements, sizeof(size_t));

		typename std::vector<T>::iterator it = dataVector->begin();
		for( ; it!=dataVector->end(); ++it)
		{
			std::ofstream::write(reinterpret_cast<char*>(&(*it)), sizeof(T));
		}
	}

	void doDataString(std::string str)
	{
		size_t numChars = str.size();
		std::ofstream::write(reinterpret_cast<char*>(&numChars), sizeof(size_t));
		std::ofstream::write(str.c_str(), static_cast<int>(numChars));
	}

protected:
private:
};



class readBinary : public std::ifstream
{
public:
	template< typename T >
		void doData(T* data)
	{
		std::ifstream::read(data, sizeof(T));
	}

	template< typename T>
		void doDataVector(typename std::vector<T>* dataVector)
	{
		size_t numElements;
		std::ifstream::read(&numElements, sizeof(size_t));

		dataVector->resize(numElements);

		typename std::vector<T>::iterator it = dataVector->begin();
		for( ; it!=dataVector->end(); ++it)
		{
			std::ifstream::read(&(*it), sizeof(T));
		}
	}

	void doDataString(std::string* str)
	{
		size_t numChars;

		char* buffer = new char[numChars+1];

		std::ifstream::read(buffer, static_cast<int>(numChars));
		buffer[numChars] = '\0';

		*str = buffer;

		delete buffer;
	}

protected:
private:
};





#endif

