
#include "program.h"


void program::generate(unsigned int seed)
{
	if(size()==0)
	{
		WARN("attempted to generate a program of length 0");
		return;
	}

	srand(seed);
	iterator it = begin();
	for( ; it!=end(); ++it)
	{
		float v = (float)rand()/RAND_MAX;
		v *= g_max_uInt;
		*it = (int)v;
	}
}

int program::read(address addr)
{
	ASSERT(size()>0,"cannot read from 0 length program");
	return (*this)[addr%size()];
}


void program::write(address addr, int val)
{
	ASSERT(size()>0,"cannot write to 0 length program");
	(*this)[addr%size()] = val;
}

