

#ifndef __program_h__
#define __program_h__



#include "common.h"



/// holds the data for a program
class program
	: public std::vector<int>
{
public:
	program() {}
	~program() {}

	/// generate a random program from the specified seed
	/**
	 *	fills the currently allocated data with
	 *	random data
	 */
	void generate(uInt seed);

	/// returns the data at the specified address
	/**
	 *	the memory is assumed to wrap round
	 *	and so all addresses are valid unless the
	 *	program is of length 0, in which case no
	 *	address is valid.
	 */
	int read(address addr);

	/// writes the data to the specified address
	/**
	 *	the memory is assumed to wrap round
	 *	and so all addresses are valid unless the
	 *	program is of length 0, in which case no
	 *	address is valid.
	 */
	void write(address addr, int val);

protected:
private:
};



#endif

