

#ifndef __types_h__
#define __types_h__


#include <vector>
#include <map>
#include <list>
#include <string>
#include <iostream>
#include <cassert>
#include <cmath>


typedef unsigned char uChar;
typedef unsigned short uShort;
typedef unsigned int uInt;



static const uInt g_max_uInt = (1<<(sizeof(uInt)*8))-1;
static const int g_max_int = (1<<(sizeof(uInt)*8))-1;
static const uChar g_max_uChar = (1<<(sizeof(uChar)*8))-1;
static const char g_max_char = (1<<(sizeof(char)*8-1))-1;
static const uShort g_max_uShort = (1<<(sizeof(uShort)*8))-1;


#define ASSERT(TEST, INFO) assert((TEST) && INFO)


#ifdef NO_WARNINGS
	#define WARN(INFO) (void(0));
#else
	#define WARN(INFO) std::cerr << "Warning: " << INFO << std::endl;
#endif


#define WARN_IF(TEST, INFO)	if(TEST) WARN("[ " #INFO " ]");


#ifdef NO_MESSAGES
	#define MSG(INFO) (void(0));
#else
	#define MSG(INFO) std::cout << "-- " INFO << std::endl;
#endif


#define MSG_IF(TEST, INFO)	if(TEST) MSG(INFO);



typedef uChar instruction;
typedef uInt threadId;
typedef uInt processId;
typedef uInt address;



#endif

