
#include "thread.h"


thread::thread()
	: m_PC(0)
	, m_terminated(true) 
{
}


thread::thread(address PC)	
	: m_PC(PC)
	, m_terminated(false) 
{
}


thread::~thread()
{
}


void thread::spawn(const address& PC)
{ 
	m_PC = PC; 
	m_terminated = false; 
}


address thread::getAddress()
{ 
	return m_PC; 
}


bool thread::isTerminated() 
{ 
	return m_terminated; 
}


thread& thread::operator++()
{ 
	++m_PC;
	return *this; 
}


thread& thread::operator+=(const int& i)
{
	m_PC+=i;
	return *this;
}


thread& thread::operator%=(const int& i)
{
	m_PC%=i;
	return *this;
}


thread& thread::operator=(const address& addr) 
{ 
	m_PC = addr; 
	return *this; 
}


thread::operator address() 
{ 
	return m_PC; 
}

