

#ifndef __thread_h__
#define __thread_h__



#include "common.h"
#include "id.h"




/// holds the data for an individual thread
class thread
{
	friend class process;

public:
	/// initialise to terminated state
	thread();

	/// initialise to specified address
	thread(address PC);

	~thread();

	/// set the thread to the specified address
	/// and flag as active
	void spawn(const address& PC);

	/// get the current address of the thread
	address getAddress();

	/// test if the thread is terminated
	bool isTerminated();

	/// move the thread to the next address
	thread& operator++();

	/// jump the thread foward by the specified number
	/// of memory addresses
	thread& operator+=(const int& i);

	/// ensure the thread is within the range
	/// [0, i[
	thread& operator%=(const int& i);

	/// set the address to the specified address
	thread& operator=(const address& addr);

	/// implicit conversion to the current address
	operator address();

protected:
	/// the current address of the thread
	address m_PC;

	/// whether the thread is terminated or active
	bool m_terminated;

private:
};



#endif

